package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.RmIndustryClassification;
import com.zksy.system.basicData.service.RmIndustryClassificationService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 行业分类及代码Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/rmIndustryClassification")
@Api(tags = "行业分类及代码", description = "行业分类及代码desc")
public class RmIndustryClassificationController extends BaseController{

    @Autowired
    private RmIndustryClassificationService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "行业分类及代码搜索getById")
    public RmIndustryClassification getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "行业分类及代码分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "行业分类及代码查询所有")
    public List<RmIndustryClassification> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增行业分类及代码
     */
    @PostMapping("/save")
    @ApiOperation(value = "行业分类及代码新增")
    @Log(title = "新增行业分类及代码", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody RmIndustryClassification rmIndustryClassification) {
        return service.save(rmIndustryClassification);
    }

    /**
     * 修改行业分类及代码
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "行业分类及代码修改")
    @Log(title = "修改行业分类及代码", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody RmIndustryClassification rmIndustryClassification) {
        return service.updateById(rmIndustryClassification);
    }

    /**
     * 导入行业分类及代码
     */
    @ApiOperation("行业分类及代码导入")
    @Log(title = "行业分类及代码", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<RmIndustryClassification> rmIndustryClassificationAll = service.list();
            List<RmIndustryClassification> list = ExcelUtils.readMultipartFile(file, RmIndustryClassification.class,RmIndustryClassification.class.getDeclaredFields().length - 2);
            if(rmIndustryClassificationAll != null && rmIndustryClassificationAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("行业分类及代码导出")
    @Log(title = "行业分类及代码", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<RmIndustryClassification> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"行业分类及代码",wrapperList,RmIndustryClassification.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "行业分类及代码", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除行业分类及代码", notes = "删除行业分类及代码")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"行业分类及代码模板");
    }
}

